# -*- coding: utf-8 -*-

import  Synergy.Visual as Visual
from Synergy import Exceptions
from Windows import Dialogs
from . import Logo
import wx.lib.pubsub as pubsub
import wx

class KlienciVisual(Visual.Visual):
    def __init__(self,*args,**kwargs):
        super(KlienciVisual,self).__init__(*args,**kwargs)

    def _Subscribe(self):
        super(KlienciVisual,self)._Subscribe()
        pubsub.Publisher().subscribe(self.OnDialogEvent, "Contacts.Events.Dialog")


    def OnDialogEvent(self,message):
        if hasattr(self,message.data[0]):
            getattr(self,message.data[0])(*message.data[1:])


    def NewContact(self,parent = None, *args,**kwargs):
        dlg=Dialogs.ContactDialog()		
        if dlg.ShowModal() == wx.ID_OK:
            contact = dlg.GetData()
            if parent != None:
                print parent
                contact.SetParent(parent)
            dlg.Destroy()
            try:						
                contact.Save()
            except Exceptions.DatabaseError,error:				
                wiad=u"Pojawił się nieoczekiwany problem z wykoniem zapytania SQL. Szczegóły błędu:\n\n"
                dlg2=wx.MessageDialog(None,wiad+error.message,u"Problem z bazą danych",wx.OK|wx.ICON_ERROR)
                dlg2.ShowModal()
                dlg2.Destroy()
        else:
            dlg.Destroy()

    def UpdateClient(self,*args,**kwargs):
        dlg=Dialogs.UpdateClientDialog(args[0],self._model)		
        if dlg.ShowModal() == wx.ID_OK:
            data= dlg.GetData()
            dlg.Destroy()
            try:
                self._model.UpdateClient(data,{'cid':args[0]})
            except Exceptions.DatabaseError,error:				
                wiad=u"Pojawił się nieoczekiwany problem z wykoniem zapytania SQL. Szczegóły błędu:\n\n"
                dlg2=wx.MessageDialog(None,wiad+error.message,u"Problem z bazą danych",wx.OK|wx.ICON_ERROR)
                dlg2.ShowModal()
                dlg2.Destroy()
        else:
            dlg.Destroy()



