# -*- coding: utf-8 -*-
import wx
from DataFields import ContactDataField


class ContactDialog(wx.Dialog):
	def __init__(self,*args,**kwargs):
		super(ContactDialog,self).__init__(parent=None,title="Nowy Kontakt...",style=wx.DEFAULT_DIALOG_STYLE,*args,**kwargs)
		self._sizerVert=wx.BoxSizer(wx.VERTICAL)		

		self._panelCtrls={}
		self._init_ctrls()

		self.SetSizer(self._sizerVert)
		#self.SetSize((700,500))
		self.SetSize(self.GetBestSize())


	def _init_ctrls(self):
		self._panelCtrls['client data']=ContactDataField(self)

		self._sizerVert.AddSizer(self._panelCtrls['client data'].GetSizer(),0,wx.GROW)		

		self._init_buttons(self._sizerVert)

	def _init_buttons(self,sizer):
		# Adding separating line
		line = wx.StaticLine(self,-1)
		sizer.Add(line,0,wx.GROW|wx.LEFT|wx.RIGHT|wx.TOP, border = 10)
		# Now buttons
		b=wx.Button(self,-1,'Zapisz Dane')
		b2=wx.Button(self,-1,u'Anuluj')
		# Horizontal sizer for buttons
		buttonSizer=wx.BoxSizer(wx.HORIZONTAL)
		buttonSizer.Add(b,1,flag=wx.ALL|wx.GROW,border=10)
		buttonSizer.Add(b2,1,flag=wx.ALL|wx.GROW,border=10)
		# Adding buttons to main sizer
		sizer.Add(buttonSizer,flag=wx.GROW|wx.LEFT|wx.RIGHT|wx.TOP, border = 10)
		# And binding them
		self.Bind(wx.EVT_BUTTON, self.OnAddButton,b)
		self.Bind(wx.EVT_BUTTON, self.OnCancelButton,b2)


	def GetData(self):
		return self._panelCtrls['client data'].GetData()

	def OnAddButton(self,event):
		try:
			#For validation
			self.GetData()
			self.EndModal(wx.ID_OK)
		except Exception,error:
			wiad=u"Problem z wprowadzonymi danymi Klienta \n \n"
			dlg2=wx.MessageDialog(None,wiad+error.message,u"Problem z danymi",wx.OK|wx.ICON_ERROR)
			dlg2.ShowModal()
			dlg2.Destroy()


	def OnCancelButton(self,event):
		self.EndModal(wx.ID_CANCEL)

class UpdateClientDialog(wx.Dialog):
	def __init__(self,cid,model,*args,**kwargs):
		super(UpdateClientDialog,self).__init__(parent=None,title="Zmiana danych klienta...",style=wx.DEFAULT_DIALOG_STYLE,*args,**kwargs)
		self._sizerVert=wx.BoxSizer(wx.VERTICAL)		

		self._panelCtrls={}
		
		self._init_ctrls(cid,model)

		self.SetSizer(self._sizerVert)
		self.SetSize(self.GetBestSize())


	def _init_ctrls(self,cid,model):
		self._panelCtrls['client data']=ContactDataField(self,model=model)
		self._panelCtrls['client data'].ShowData(cid)
			
		self._sizerVert.AddSizer(self._panelCtrls['client data'].GetSizer(),0,wx.GROW)		

		b=wx.Button(self,wx.ID_OK)
		b2=wx.Button(self,wx.ID_CANCEL)
		sizer=wx.BoxSizer(wx.HORIZONTAL)
		sizer.Add(b,1,flag=wx.ALL|wx.GROW,border=10)
		sizer.Add(b2,1,flag=wx.ALL|wx.GROW,border=10)
		self._sizerVert.Add(sizer,flag=wx.GROW)
		self.Bind(wx.EVT_BUTTON, self.OnAddButton,b)


	def GetData(self):
		return self._panelCtrls['client data'].GetData()

	def OnAddButton(self,event):
		try:
			#For validation
			self.GetData()
			self.EndModal(wx.ID_OK)
		except Exception,error:
			wiad=u"Problem z wprowadzonymi danymi Klienta \n \n"
			dlg2=wx.MessageDialog(None,wiad+error.message,u"Problem z danymi",wx.OK|wx.ICON_ERROR)
			dlg2.ShowModal()
			dlg2.Destroy()


	def OnCancelButton(self,event):
		self.EndModal(wx.ID_CANCEL)


